"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useQueries = void 0;
const core_1 = require("react-query/core");
const vue_1 = require("vue");
const useQueryClient_1 = require("./useQueryClient");
const utils_1 = require("./utils");
function useQueries(queries) {
    const queryClient = useQueryClient_1.useQueryClient();
    const observer = new core_1.QueriesObserver(queryClient, queries);
    const state = vue_1.reactive(observer.getCurrentResult());
    const unsubscribe = observer.subscribe((result) => {
        state.forEach((stateEntry, index) => {
            utils_1.updateState(stateEntry, result[index]);
        });
    });
    vue_1.watchEffect(() => {
        observer.setQueries(queries);
    });
    vue_1.onUnmounted(() => {
        unsubscribe();
    });
    return vue_1.toRefs(vue_1.readonly(state));
}
exports.useQueries = useQueries;
