"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateState = exports.parseMutationArgs = exports.parseFilterArgs = exports.parseQueryArgs = exports.isQueryKey = void 0;
function isQueryKey(value) {
    return typeof value === "string" || Array.isArray(value);
}
exports.isQueryKey = isQueryKey;
function parseQueryArgs(arg1, arg2, arg3) {
    if (!isQueryKey(arg1)) {
        return arg1;
    }
    if (typeof arg2 === "function") {
        return { ...arg3, queryKey: arg1, queryFn: arg2 };
    }
    return { ...arg2, queryKey: arg1 };
}
exports.parseQueryArgs = parseQueryArgs;
function parseFilterArgs(arg1, arg2, arg3) {
    return (isQueryKey(arg1)
        ? [{ ...arg2, queryKey: arg1 }, arg3]
        : [arg1 || {}, arg2]);
}
exports.parseFilterArgs = parseFilterArgs;
function parseMutationArgs(arg1, arg2, arg3) {
    if (isQueryKey(arg1)) {
        if (typeof arg2 === "function") {
            return { ...arg3, mutationKey: arg1, mutationFn: arg2 };
        }
        return { ...arg2, mutationKey: arg1 };
    }
    if (typeof arg1 === "function") {
        return { ...arg2, mutationFn: arg1 };
    }
    return { ...arg1 };
}
exports.parseMutationArgs = parseMutationArgs;
function updateState(state, update) {
    Object.keys(state).forEach((key) => {
        state[key] = update[key];
    });
}
exports.updateState = updateState;
